#include <iostream>
#include <cstdlib>
#include <string>
#include <cmath>
#include "TVerseny.h"
#include "TVersenyzo.h"
#include "console.h"
#include "random.h"

using namespace std;

Console::Color TVersenyzo::szinek[] = { Console::Gray,  Console::Green, Console::Cyan, Console::Red,
                                        Console::Magenta, Console::Yellow, Console::White};
int TVersenyzo::szinekSzama = sizeof(TVersenyzo::szinek)/sizeof(Console::Color);

Random TVersenyzo::velszam;

int TVersenyzo::versenyzokSzama = 0;

TVersenyzo::TVersenyzo() {
    Init(versenyzokSzama+1, szinek[velszam.Next(0,szinekSzama)]);
}

TVersenyzo::TVersenyzo(int mez) {
    Init(mez, szinek[velszam.Next(0,szinekSzama)]);
}

TVersenyzo::TVersenyzo(int mez, Console::Color szin)  {
    Init(mez, szin);
}

void TVersenyzo::Init(int mez, Console::Color szin) {
    this->mez = mez;
    this->szin = szin;
    helyzet = 0;
    versenyzokSzama++;
    szokozok.append(log10(mez)+1, ' '); // a szmjegyek szmval megegyez szm szkz a trlshez
}

void TVersenyzo::Fut(TVerseny *verseny) {
    // Letrljk az elz helyet:
    Console::SetCursorPosition(helyzet, mez - 1);
    cout << szokozok;
    // Lptetjk a versenyzt:
    helyzet += velszam.Next(1, maxLepes + 1);
    if (helyzet >= verseny->palya->hossz) {
        // Feljegyezzk a clba r versenyz mezszmt:
        verseny->gyoztesek.push_back(mez);
        // Trljk a clvonalat a versenyz sorban:
        Console::SetCursorPosition(verseny->palya->hossz, mez - 1);
        cout << " ";
    }
    Kiir();
}

void TVersenyzo::Kiir() {
    // Megjelentjk a versenyz helyt:
    Console::SetCursorPosition(helyzet, mez-1);
    Console::SetForegroundColor(szin);
    cout << mez;
}
