#include <iostream>
#include <string>
#include <sstream>
#include "windows.h"
#include "console.h"
#include "TVerseny.h"
#include "TVersenyzo.h"
using namespace std;

void TVerseny::SetVersenyzokSzama(int ertek) {
    if (0 < ertek && ertek < Console::GetLargestWindowHeight()-5)
        versenyzokSzama = ertek;
    else
        versenyzokSzama = 0;
}

void TVerseny::SetGyoztes(int ertek) {
	if (0 < ertek && ertek <= versenyzokSzama) {
			gyoztesek.push_back(ertek);
    }
}

void TVerseny::Start() {
    Console::SetTitle("Futverseny");
    // Beolvassuk a versenyzk szmt:
    int szam;
    do {
        cout << "A versenyzk szma (<" << Console::GetLargestWindowHeight()-5  << "): ";
        cin >> szam; cin.get();
        SetVersenyzokSzama(szam);
    } while (GetVersenyzokSzama() == 0 );
    // Ltrehozzuk a versenyzket tartalmaz tmbt:
    versenyzok.resize(GetVersenyzokSzama());
    for (unsigned i=0; i<versenyzok.size(); i++) {
        versenyzok[i] = new TVersenyzo(i+1);
        versenyzok[i]->SetNev("V " + IntToString(i+1));
    }

    // Ltrehozzuk a plyaobjektumot:
    palya = new TPalya(GetVersenyzokSzama());

    // Elindtjuk a versenyt:
    Futas();

    // Kirjuk a gyzteseket:
    Eredmeny();
    cout << "(Enter: kilp)";

    // Trljk a dinamikus objektumokat:
    delete palya;
    for (unsigned i=0; i<versenyzok.size(); i++) {
		delete versenyzok[i];
    }
}

void TVerseny::Futas() {
    do {
        for(int i=0; i<GetVersenyzokSzama(); i++)
            versenyzok[i]->Fut(this);
        Var(szunet);
    } while (gyoztesek.size() == 0);
    Console::SetForegroundColor(Console::White);
    cout<<endl<<"Vge a versenynek."<<endl;
}

void TVerseny::Eredmeny() {
    Console::SetForegroundColor(Console::White);
    cout <<"Gyztt: ";
    for (unsigned int i=0; i < gyoztesek.size(); i++)
        cout << versenyzok[gyoztesek.at(i)-1]->GetNev() << "; ";
    cout << endl;
}

void TVerseny::Var(int idotartam)
{
    Sleep(idotartam);
}

string TVerseny::IntToString(int szam) { // sztringg alaktja az int rtket
	stringstream ss;
	ss << szam;
	return ss.str();
}
