#include <iostream>
#include <sstream>
#include <string>
#include <cmath>
using namespace std;

#include "TSikidom.h"

TSikidom::TSikidom(float x, float y, float a) {
    this->x = x;
    this->y = y;
    this->a = a;
}

float TSikidom::Tavolsag() const {
    // a kzppont tvolsga az origtl
    return (float)sqrt(x * x + y * y);
}

string TSikidom::ToString() const {
 	stringstream ss;
    ss << nev << endl;
    ss << "x = " << x << " y = " << y << endl;
    ss << "Tvolsg az origtl: " << Tavolsag() << endl;
    ss << "Terlet: " << Terulet() << endl;
    ss << "a = " << a << endl;
	return ss.str();
}

bool TSikidom::operator < (const TSikidom & sikidom) const {
	return this->Terulet() < sikidom.Terulet();
}
