#include <iostream>
#include <iomanip>
#include <clocale>
#include <algorithm>

using namespace std;
#include "TObject.h"
#include "TSikidom.h"
#include "TTeglalap.h"
#include "TEllipszis.h"
#include "Random.h"

bool Osszehasonlito (TSikidom *p, TSikidom*q) { return *p < *q; }

int main()
{
    setlocale(LC_ALL,"Hun");
    typedef TSikidom *PSikidom;

	PSikidom *sikidom = new PSikidom[10];
	Random velszam;
	float a,b,x,y;

	for (int i = 0; i < 10; i++) {
        a = velszam.Next(1, 20);
        b = velszam.Next(1, 20);
        x = velszam.Next(1, 20);
        y = velszam.Next(1, 20);
		switch (velszam.Next(1, 5)) {
			case 1:
				sikidom[i] = new TKor(x, y, a);
				break;
			case 2:
				sikidom[i] = new TEllipszis(x, y, a, b);
				break;
			case 3:
				sikidom[i] = new TNegyzet(x, y, a);
				break;
            default:
				sikidom[i] = new TTeglalap(x, y, a, b);
				break;
		}
	}

    cout<<"Eredeti sorrend:"<<endl;
	for (int i = 0; i < 10; i++) {
	    cout.width(10);
	    cout.precision(4);
	    cout << fixed;
		cout << sikidom[i]->Terulet() << " " << sikidom[i]->GetNev() << endl;
	}
	cout<<endl;

    // Rendezs:
    sort(sikidom, sikidom+10, Osszehasonlito);

    cout << "Rendezett sorrend:" << endl;
	for (int i = 0; i < 10; i++) {
	    cout.width(10);
	    cout.precision(4);
	    cout << fixed;
		cout << sikidom[i]->Terulet() << " " << sikidom[i]->GetNev() << endl;
	}
	cout << endl;

	for (int i = 0; i < 10; i++) {
	    delete sikidom[i];
	}
	delete[] sikidom;
    cin.get();
}
