#include <iostream>
#include <fstream>
#include <string>
#include <vector>
#include <clocale>
using namespace std;

const string ut  = "utkereses1.txt";  // az adatokat tartalmaz fjl elrsi tja
const char utch = '.';

vector < vector<char> > tabla;

int sordb, oszlopdb;

void Utkereses(int&, int&, bool&);
void Feltolt();
void Kiir();

int main()
{
    int sor = 1;
    int oszlop = 1;
    bool kesz;

    setlocale(LC_ALL,"Hun");

    Feltolt();
    Kiir();
    Utkereses(sor, oszlop, kesz);
    if (kesz)
        Kiir();
    else
        cout << "Nincs megolds";

    cin.get();
    return 0;
}

void Utkereses(int& sor, int& oszlop, bool& kesz) { // tkeress itercival
    tabla[sor][oszlop] = utch;
    kesz = (sor == sordb && oszlop == oszlopdb);
    while (!kesz && sor >=1 && oszlop>=1) {
        // A kvetkez lps keresse:
        tabla[sor][oszlop] = utch; // bejelljk, hogy elrtk ezt a cellt
        if (tabla[sor][oszlop+1] == ' ') // jobbra lpnk
            oszlop++;
        else if (tabla[sor+1][oszlop] == ' ') // lefel lpnk
            sor++;
        else {// visszalpnk
            tabla[sor][oszlop] = '-'; // letiltjuk a cellt, hogy mg egyszer ne jjjnk erre
            if (tabla[sor][oszlop-1] == utch) // balrl jttnk
                oszlop--;
            else // fentrl jttnk
                sor--;
        }
        kesz = (sor == sordb && oszlop == oszlopdb);
        if (kesz)
            tabla[sor][oszlop] = utch;
    }
}

void Feltolt() {
    ifstream fajl;
    string sor;

    fajl.open(ut.c_str());
    fajl >> sordb;  fajl.get();
    oszlopdb = sordb;

    //  A tbla dinamikus ellltsa: bels mret + 2 a szleknek
    tabla.resize(sordb+2);
    for (int i=0; i<sordb+2; i++)
       tabla[i].resize(oszlopdb+2);

    int i = 0;
    while (!fajl.eof()) {
        getline(fajl, sor);
        for (int j=0; j<sor.length(); j++) {
            switch (sor[j]) {
                case utch : tabla[i+1][j+1] = ' '; break;
                case 'x' : tabla[i+1][j+1] = 'X'; break;
                default  : tabla[i+1][j+1] = '?';
            }
        }
        i++;
    }
    fajl.close();

    for (int i=0; i<sordb+2; i++) { // a szlek feltltse
        tabla[0][i] = 'X';
        tabla[sordb+1][i] = 'X';
        tabla[i][0] = 'X';
        tabla[i][oszlopdb+1] = 'X';
    }

    // bejrat, kijrat:
    tabla[1][0] = ' ';
    tabla[sordb][oszlopdb+1] = ' ';
}

void Kiir() {
    for (int i=0; i<sordb+2; i++) {
        for (int j=0; j<oszlopdb+2; j++)
             cout << tabla[i][j];
        cout << endl;
    }
    cout << endl;
}
